<?php

namespace Jlr\Tags\Api\Endpoint;

class FetchReports extends \Jane\OpenApiRuntime\Client\BaseEndpoint implements \Jane\OpenApiRuntime\Client\Psr7HttplugEndpoint
{
    /**
     * 
     *
     * @param array $queryParameters {
     *     @var string $filter[id] The id of the report to retrieve
     *     @var string $filter[title] The title of the report to retrieve
     *     @var bool $filter[favourite] Only return reports that have been favourited
     *     @var string $sort[title] The field to sort by. Default sorting as ascending, adding the `-` will sort descending.
     *     @var int $page[number] Get the reports from the current page
     *     @var int $page[size] Set the total number of reports to get in a single request
     *     @var string $include Comma separated list of all the relationships you want to include
     * }
     */
    function __construct(array $queryParameters = array())
    {
        $this->queryParameters = $queryParameters;
    }
    use \Jane\OpenApiRuntime\Client\Psr7HttplugEndpointTrait;
    function getMethod() : string
    {
        return 'GET';
    }
    function getUri() : string
    {
        return '/reports';
    }
    function getBody(\Symfony\Component\Serializer\SerializerInterface $serializer, \Http\Message\StreamFactory $streamFactory = null) : array
    {
        return array(array(), null);
    }
    function getExtraHeaders() : array
    {
        return array('Accept' => array('application/json'));
    }
    protected function getQueryOptionsResolver() : \Symfony\Component\OptionsResolver\OptionsResolver
    {
        $optionsResolver = parent::getQueryOptionsResolver();
        $optionsResolver->setDefined(array('filter[id]', 'filter[title]', 'filter[favourite]', 'sort[title]', 'page[number]', 'page[size]', 'include'));
        $optionsResolver->setRequired(array());
        $optionsResolver->setDefaults(array());
        $optionsResolver->setAllowedTypes('filter[id]', array('string'));
        $optionsResolver->setAllowedTypes('filter[title]', array('string'));
        $optionsResolver->setAllowedTypes('filter[favourite]', array('bool'));
        $optionsResolver->setAllowedTypes('sort[title]', array('string'));
        $optionsResolver->setAllowedTypes('page[number]', array('int'));
        $optionsResolver->setAllowedTypes('page[size]', array('int'));
        $optionsResolver->setAllowedTypes('include', array('string'));
        return $optionsResolver;
    }
    /**
     * {@inheritdoc}
     *
     *
     * @return null|\Jlr\Tags\Api\Model\ReportsGetResponse200
     */
    protected function transformResponseBody(string $body, int $status, \Symfony\Component\Serializer\SerializerInterface $serializer, ?string $contentType = null)
    {
        if (200 === $status && 'application/json' === $contentType) {
            return $serializer->deserialize($body, 'Jlr\\Tags\\Api\\Model\\ReportsGetResponse200', 'json');
        }
        if (401 === $status) {
        }
    }
}