<?php

namespace Jlr\Tags\Contracts;

use Jlr\Tags\Api\Client as BaseClient;
use Jlr\Tags\Api\Model\Tag;
use Jlr\Tags\Api\Model\TagGroup;

interface Client
{
    /**
     * @return \Jlr\Tags\Api\Model\Tag|\Psr\Http\Message\ResponseInterface|null
     */
    public function fetchTag(Tag $requestBody, string $fetch = BaseClient::FETCH_OBJECT);

    /**
     * @return \Jlr\Tags\Api\Model\TagsGetResponse200|\Psr\Http\Message\ResponseInterface|null
     */
    public function fetchTags(array $queryParameters = [], string $fetch = BaseClient::FETCH_OBJECT);

    /**
     * @return \Jlr\Tags\Api\Model\TagsSlugPatchResponse200|\Psr\Http\Message\ResponseInterface|null
     */
    public function updateTag(string $slug, Tag $requestBody, string $fetch = BaseClient::FETCH_OBJECT);

    /**
     * @return \Jlr\Tags\Api\Model\TagGroupsGetResponse200|\Psr\Http\Message\ResponseInterface|null
     */
    public function fetchTagGroups(array $queryParameters = [], string $fetch = BaseClient::FETCH_OBJECT);

    /**
     * @return \Jlr\Tags\Api\Model\TagGroup|\Psr\Http\Message\ResponseInterface|null
     */
    public function fetchTagGroup(TagGroup $requestBody, string $fetch = BaseClient::FETCH_OBJECT);

    /**
     * @return \Jlr\Tags\Api\Model\TagGroupsIdPatchResponse200|\Psr\Http\Message\ResponseInterface|null
     */
    public function updateTagGroup(int $tagGroupId, TagGroup $requestBody, string $fetch = BaseClient::FETCH_OBJECT);

    /**
     * @return \Jlr\Tags\Api\Model\TagsPostResponse200|\Psr\Http\Message\ResponseInterface|null
     */
    public function createTag(Tag $requestBody, string $fetch = BaseClient::FETCH_OBJECT);

    public function equals(Tag $first, Tag $second): bool;
}
